// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "EntityAttackBase.hpp"
#include "scene/components/entity/EntityFaction.hpp"

namespace Dawn {
  class SwordHitbox;

  class EntitySwordAttack : public EntityAttackBase {
    protected:
      float_t attackTime = -1;
      SwordHitbox *hurtboxItem = nullptr;

    public:
      // @optional
      glm::vec3 attackOffset = glm::vec3(0,0,1);
      // @optional
      glm::vec3 attackSize = glm::vec3(1,1,1);

      EntitySwordAttack(SceneItem* item);

      void onStart() override;
      void onDispose() override;
      
      float_t getAttackRampUpDuration() override;
      float_t getAttackActiveDuration() override;
      float_t getAttackRampDownDuration() override;
      float_t getAttackCooldownDuration() override;
      bool_t isInterruptable() override;
      bool_t canAttack() override;
  };
}